Module LocateDb
    ' Fix the connection string so it finds the
    ' database in our working directory.
    Public Sub FixupConnectionString()
        ' Get the initial connection string.
        Dim connect_string As String = _
            CStr(My.Settings.Item("ComputerUsersConnectionString"))
        Debug.WriteLine("Old connection string: " & connect_string)

        ' Find the "Data Source" token.
        Dim pos1 As Integer = connect_string.IndexOf("Data Source=")
        ' Find open quote for the data source.
        pos1 = connect_string.IndexOf("""", pos1)
        ' Find where the database file name ends.
        Dim pos2 As Integer = connect_string.IndexOf(".mdb", pos1)
        ' Find where the database file name begins.
        pos2 = connect_string.LastIndexOf("\", pos2)

        ' Get the path to our working directory.
        Dim db_path As String = Application.StartupPath
        db_path = db_path.Substring(0, db_path.LastIndexOf("\bin\"))

        ' Replace the path to the database with our path.
        connect_string = _
            connect_string.Substring(0, pos1 + 1) & _
            db_path & _
            connect_string.Substring(pos2)

        ' Save the new value.
        My.Settings.Item("ComputerUsersConnectionString") = connect_string

        Debug.WriteLine("New connection string: " & connect_string)
    End Sub
End Module
