Imports System.ServiceModel
Imports System.IO

Namespace VBHelper.FortuneServer

    ' Define the service contract.
    <ServiceContract([Namespace]:="http://VBHelper.FortuneServer")> _
    Public Interface IFortunePicker
        ' Return a random fortune.
        <OperationContract()> _
        Function GetFortune() As String
    End Interface

    ' Implement the IFortunePicker interface.
    Public Class FortunePicker
        Implements IFortunePicker

        Private m_Random As Random

        Public Sub New()
            m_Random = New Random()
        End Sub

        ' Return a random fortune.
        Public Function GetFortune() As String Implements IFortunePicker.GetFortune
            Dim quotes() As String = { _
                "I stand by all the misstatements that I've made. -- Dan Quayle", _
                "You can observe a lot just by watching. -- Yogi Berra", _
                "Things are more like they are now than they have ever been. -- Gerald Ford", _
                "A zebra  does not change its spots. -- Al Gore", _
                "If it weren't for electricity, we'd all be watching television by candlelight. -- George Gobel", _
                "Listen, everyone is entitled to my opinion. -- Madonna", _
                "A friend is someone who's there when he needs you. -- Anon", _
                "I'm gonna live forever, or die trying. -- Joseph Heller (Catch 22)", _
                "Trees cause more pollution than automobiles do. -- Ronald Regan", _
                "Two nations divided by a common language. -- Winston Churchill" _
            }

            ' Pick a random quote.
            Dim quote As String = quotes(m_Random.Next(0, quotes.Length))

            ' Write to the Console window so we can see
            ' that the server is doing something.
            Console.WriteLine(Now.ToString() & ": " & quote)

            ' Save a record in the log file.
            Using stream_writer As StreamWriter = File.AppendText("C:\Windows\Fortunes.log")
                stream_writer.WriteLine(Now.ToString() & ": " & quote)
            End Using

            ' Return the selected quote.
            Return quote
        End Function
    End Class

End Namespace
