Imports System.IO
Imports System.Reflection
Imports System.Resources

Public Class Form1
    Private m_TargetAssembly As Assembly

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Get the target application.
        txtFile.Text = My.Computer.FileSystem.CombinePath( _
            Application.StartupPath, _
            "..\..\..\ContainsResources\bin\Debug\ContainsResources.exe")
        txtFile.Select(0, 0)
    End Sub

    ' List the target assembly's resources.
    Private Sub btnList_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnList.Click
        ' Get the target assembly.
        m_TargetAssembly = Assembly.LoadFile(txtFile.Text)

        ' List the target's manifest resource names.
        lstResourceFiles.Items.Clear()
        For Each str As String In m_TargetAssembly.GetManifestResourceNames()
            lstResourceFiles.Items.Add(str)
        Next str
    End Sub

    ' List this file's resources.
    Private Sub lstResourceFiles_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstResourceFiles.SelectedIndexChanged
        lstResources.Items.Clear()

        Dim resource_reader As New ResourceReader( _
            m_TargetAssembly.GetManifestResourceStream(lstResourceFiles.Text))
        Dim dict_enumerator As IDictionaryEnumerator = resource_reader.GetEnumerator()
        While dict_enumerator.MoveNext()
            lstResources.Items.Add(New ResourceInfo( _
                dict_enumerator.Key, _
                dict_enumerator.Value))
        End While
        resource_reader.Close()
    End Sub

    ' Display the selected resource.
    Private Sub lstResources_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstResources.SelectedIndexChanged
        lblString.Text = ""
        picImage.Image = Nothing

        Dim resource_info As ResourceInfo = _
            DirectCast(lstResources.SelectedItem, ResourceInfo)
        Select Case resource_info.Value.GetType.Name
            Case "Bitmap"
                picImage.Image = CType(resource_info.Value, Bitmap)
                lblString.Text = ""
            Case "String"
                picImage.Image = Nothing
                lblString.Text = CType(resource_info.Value, String)
        End Select
    End Sub

    Private Class ResourceInfo
        Public Key As Object
        Public Value As Object
        Public Sub New(ByVal new_key As Object, ByVal new_value As Object)
            Key = new_key
            Value = new_value
        End Sub
        Public Overrides Function ToString() As String
            Return Key.ToString & " (" & Value.ToString & ")"
        End Function
    End Class
End Class
